import re

# Match added log lines such as: 
# +  logger.info("An event occurred")
log_add_pattern = re.compile(r'^\+(?!\+)(?!(\s)*//)(.)*log(\w)*(\(\))?\.(fatal|error|warn|info|debug|trace|log|catching|throwing|entry|exit|printf)\(.*', 
        re.IGNORECASE)

# Match deleted log lines such as:
# -  logger.error("There is an error")        
log_del_pattern = re.compile(r'^-(?!-)(?!(\s)*//)(.)*log(\w)*(\(\))?\.(fatal|error|warn|info|debug|trace|log|catching|throwing|entry|exit|printf)\(.*', 
        re.IGNORECASE)

# Match nomal log lines such as:
#    logger.warn("Please pay attention here")
# This pattern helps us identify the log changes on multi-lines logging statements, 
# which change other lines of a logging statement instead of the line contain log-related pattern.
log_normal_pattern = re.compile(r'^(?!\+|-)(?!(\s)*//)(.)*log(\w)*(\(\))?\.(fatal|error|warn|info|debug|trace|log|catching|throwing|entry|exit|printf)\(.*', 
        re.IGNORECASE)